Device 18F452
'Device 16F877A
'OPTIMISER_LEVEL=5
'ICD_REQ =  On 
BOOTLOADER = On 
XTAL 20

STACK_SIZE = 40
ALL_DIGITAL = TRUE
PORTB_PULLUPS = true
INTERNAL_FONT = On
FONT_ADDR = 0

HSERIAL_BAUD  = 57600
HSERIAL_RCSTA = %10010000
HSERIAL_TXSTA = %00100100
HSERIAL_CLEAR = On
Include "BASIC_INTS.INC"
Include "DEFS18.inc"
Include "GLCDforEP4.inc"

'ENABLE debug


Symbol DQPin = 6
Symbol DQ = PORTB.DQPin ' Alias DS1820 data pin 

Symbol key1=PORTA.0  'PORTB.1
Symbol key2=PORTA.1  'PORTB.2
Symbol key3=PORTA.2  'PORTB.5

Symbol RxPin = 7     'PORTC.7
Symbol TxPin = 6       'PORTC.6
Symbol TxPin1 = 5

Symbol SEARCH_ROM = $F0
Symbol Scip_ROM   = $CC
Symbol MatchROM   = $55
Symbol ReadROM    = $33
Symbol WriteMem   = $55
Symbol Convert    = $3C
Symbol ReadMem    = $AA
Symbol BootLoad   = $EE

Symbol Dev_NumAd  = $0
Symbol DevTabAd   = 8  
Symbol FlashDevAd = $4000    ' 16kbytes

Symbol Resol_16   = $00      ' 16 Bit
Symbol Resol_15   = $0F      ' 15 Bit
Symbol Resol_12   = $0C      ' 12 Bit
Symbol Resol_11   = $0B      ' 11 Bit
Symbol Resol_10   = $0A      ' 10 Bit

Symbol Resol      = Resol_12                   ' Actual ADC Resolution Settings
Symbol RefV       = 512                        ' 512 for 5.12V,  256 for 2.56V 
Symbol NormShift  = 16 - Resol                 ' Normalizing shift right for <16 bit resolution

' OVERSAMPLING SETTINGS 
'Symbol OverResol    = 10                       ' Desired Oversample Resolution
'Symbol OverShift    = OverResol - Resol        ' Shift Left After Oversampling 
'Symbol OverSample   = 1<<2*OverShift           ' Count of Oversample measurements
Symbol MashtabShift = 0'512/RefV '+ OverShift     ' Norm to Vref And Scale


Symbol InMask     =    %00001111        '$0F
Symbol ReadOut    = $00

Symbol Byte_NoRes   = 0        ' No Reset, Byte mode 
Symbol Res_Byte     = 1        ' Reset before data, Byte mode 
Symbol Byte_Res     = 2        ' Reset after data, Byte mode 
Symbol Res_Byte_Res = 3        ' Reset before and after data, Byte mode 
Symbol Bit_NoRes    = 4        ' No Reset, Bit mode 
Symbol Res_Bit      = 5        ' Reset before data, Bit mode 
Symbol Bit_Res      = 6        ' Reset after data, Bit mode 
Symbol Res_Bit_Res  = 7        ' Reset before and after data, Bit mode 
Symbol Range512     = 1
Symbol Range255     = 0

' Allocate variables
Dim id_bit                As Bit        ' result of bit read from SearchROM command
Dim cmp_id_bit            As Bit        ' complement of the bit read
Dim LastDeviceFlag        As Bit        ' flag previous search was last device
Dim search_direction      As Bit        ' bit indicates direction of search. 

'Dim id_bit                As Byte        ' result of bit read from SearchROM command
'Dim cmp_id_bit            As Byte        ' complement of the bit read
'Dim LastDeviceFlag        As Byte        ' flag previous search was last device
'Dim search_direction      As Byte        ' bit indicates direction of search. 
Dim id_bit_number         As Byte       ' The ROM bit number currently being searched
Dim id_ROM                As Byte       ' tracks ROM_ON value integer
Dim id_ROM_bit            As Byte       ' tracks bits in ROM_ON value
Dim LastDiscrepancy       As Byte       ' bit index from which bit (next)search discrepency check should start
Dim LastFamilyDiscrepancy As Byte       ' bit index identifies last discrepacy within first 8 bit family code of ROM 
Dim Last_Zero             As Byte       ' bit position of last zero written 
Dim ROM_NO[8]             As Byte       ' Current ROM number being searched
Dim DeviceCount           As Byte       ' devices found
Dim tempROM               As Byte
Dim RegDevs               As Byte       ' Device number 

Dim FlDevAd               As Word
Dim Range                 As Byte
   
Dim MAIN_BYTE_CNT         As Byte 
Dim CRC8                  As Byte                                           ' bigger but faster
Dim CRC8E                 As Word
Dim Total                 As DWord
Dim I                     As Byte
Dim B                     As Byte
Dim Equal                 As Byte

Dim CRC16                 As Word
Dim CRC16Copy             As Word  
Dim CurrDev               As Byte
Dim MPage                 As Byte

Dim Result[10]            As Byte 
Dim ResultW[5]            As Word At Result
Dim CMDArray[16]          As Byte
Dim ADC_Acc[16]           As Word
Dim Index                 As Byte
Dim OverCount             As Byte

Dim DSAddr                As Byte

Dim ADC_Out               As Byte
Dim Set_Out               As Byte
Dim Dev_Out               As Byte    

Dim FlashRead             As Byte
 
Dim CMD                   As Byte

Dim CRC16E                  As Word
Dim NoPresE               As Word
Dim Stat                  As Byte
Dim ExitSort              As Byte  
Dim TempW                 As Word

    On_Interrupt GoTo ISR
TRISC.5 = 1
Input PORTA    
Input DQ
High DQ                                 'high for charge period for parasite 1- wire configuration
Clear
Cls

If RefV = 512 Then 
Range        = 1
Else
Range        = 0
EndIf 


    HRSOut "TEST 12.12.07",LF,CR
    
    INTCON    = $C0        ' Enable GIE,PIE, interruptS
    RCIE=1
    GIE=1
    T0CON  = %00000100    ' Prescaller = 1:128'1.7 sec timeout for PassThru Mode @ 20MHz 
       
MainLoop: 
    Cls   
    Print At 0,0,"TEST 12.12"
    DelayMS 1000
    If PORTA.1 = 0 Then SortDevs
    Cls
    RegDevs = ERead Dev_NumAd
setup1:    
    GoSub Setup
    
    While 1=1
        For CurrDev=1 To RegDevs
          While PORTA.2 = 0 : Wend
          GoSub GetDevNo
          If Dev_Out=1 Then GoSub SendDev  
          GoSub ReadADC          
          If PORTA.1 = 0 Then SortDevs
        DelayMS 100   
        Next CurrDev
        If Stat =1 Then GoSub StatOut
        If PORTA.1 = 0 Then SortDevs
        GoSub PrintGLCD
        If ADC_Out=1 Then GoSub SendADC
 '       Clear ADC_Acc
        Print At 7,0, "                     "
        DelayMS 100 
        Inc Total          
    Wend

        
End
StatOut:
        HRSOut "NoPE:",DEC4 NoPresE, " CRC8E:", DEC4 CRC8E," CRC16E: ", DEC4 CRC16E," TOTAL:", DEC4 Total, 13, 10
Return

SendDev:     
    HRSOut DEC2 RegDevs," ", DEC2 CurrDev," ", HEX2 ROM_NO[7]," ",HEX2 ROM_NO[6],    HEX2 ROM_NO[5],_
           HEX2 ROM_NO[4],   HEX2 ROM_NO[3],   HEX2 ROM_NO[2],    HEX2 ROM_NO[1]," ",HEX2 ROM_NO[0],13,10  
Return


  
ISR:
Context SAVE
      SYSTEM_SAVE
      If RCIF=1 Then GoSub RXD 
      SYSTEM_RESTORE
retfie       

RXD:
    Print At 7,20, "I"
 
    CMD=RCREG

    Select CMD
    Case "A"            ' Transmit ADC Results
    ADC_Out=1
    
    Case "R"
    GIE = 1
    GoTo SortDevs
    
    Case "r"
    ExitSort = 1
                                                             
    Case "D"            ' Send Devices enumeration
    Dev_Out=1
    
    Case "P"            ' Transmit Pages 1-3
    Set_Out=1
                                                                                           
    Case "S"            ' Stop Transmit   
    ADC_Out=0
    Set_Out=0
    Dev_Out=0
    Stat   =0
    
    Case "s"
    Stat = 1
    
    Case 193
    Cls
    Print At 1,1, "BOOTLOADER MODE!"     
    @ GoTo 0
    
    Case "a"
    GoSub PassThru 
     
    End Select
    
    If OERR=1 Then CREN=0
    CREN=1
    CMD=RCREG : CMD=RCREG    
Return  
'===================22==================================
 PassThru:
     Cls
     Print At 1,1, "PassThru Mode"
Retry:     
     OWrite DQ, Res_Byte, Retry,[Scip_ROM, BootLoad]
     ORead DQ, Byte_NoRes,Retry,[Result[0]]
     If Result[0]<> BootLoad Then Retry
     LATC.5 = 0
     LATB.6 = 0
     TMR0IF = 0
     TIMER0 = 0

     bsf TRISB, DQPin, 0         'TRISB.6 = 1 
Pass:                            ' While 1=1                      
     btfss  PORTC, RxPin
     bra $ - 1
M1:
     btfsc PORTB, DQPin,  0      'TRISC.5 = DQ
     bsf   TRISC, TxPin1, 0
                
     btfss PORTB, DQPin,  0
     bcf   TRISC, TxPin1, 0
     If TMR0IF = 1 Then  ExitPass 
     btfsc PORTC, RxPin
     bra M1
          
     TMR0ON = 1 
            
     bcf   TRISB, DQPin, 0           
     bcf   TRISC, TxPin1,0           
     
     btfss PORTC, RxPin, 0
     bra $ - 1     

     bsf   TRISB, DQPin, 0           
 '    bsf   TRISC, TxPin1,0               
     TIMER0 = 0
     bra Pass         
ExitPass: 
     TMR0ON = 0     
     TMR0IF = 0                      
Return     
'========================================================          

Conversion:
      OWrite DQ, Res_Byte, No_PresC,[Scip_ROM]
      Str CMDArray = Convert, InMask, ReadOut
      OWrite DQ, Byte_NoRes, No_PresC,[Str CMDArray \3]
      ORead  DQ, Byte_NoRes, No_PresC,[Str Result \2]
'      CRC16Copy.LowByte = Result[0] ^$FF : CRC16Copy.HighByte = Result[1] ^$FF
      GoSub CRC_Update [0,0, Result[0], Result[1], 3], CRC16
      If CRC16<>0 Then
      Print At 2,0, "Conv CRC ERROR !" 
      HRSOut "Conv CRC ERROR ! "
      HRSOut BIN16 ADC_Acc[0]," ", Dec ADC_Acc[0], 13,10
 
      Inc CRC16E : Print At 7,9,"C!"
      EndIf
      DelayMS 16
      Result[0]=0
      While Result[0]=0
      ORead  DQ, Byte_NoRes, No_PresC,[Result[0]]
      Print At 7,19, HEX1 Result[0]
      Wend
Return

No_PresC:
    Cls
    Print At 2,0, "Conv No Devices !!!"
    HRSOut "Conv No Devices !!!", 13,10
    Inc NoPresE
GoTo Conversion    


GetDevNo:
    Print At 2,1,DEC2 CurrDev," "                ' Deb 
      For  B=0 To 7 
      FlDevAd = FlashDevAd + 8*(CurrDev -1)+ B    
      ROM_NO[B] = CRead FlDevAd      ' get Dev number from Flash   
      Print HEX2 ROM_NO[B]    ' Deb
      Next B
      Print "  "
Return

ReadADC:   
    DSAddr=0  
      GoSub Conversion                          
      GoSub ReadPage0    
      Index = 4*(CurrDev -1)
      For I=0 To 3
        ADC_Acc[Index] = ResultW[I] >> NormShift
        Inc Index
      Next I         
Return   
 

ReadPage0:
    DSAddr=0 

    OWrite DQ, Res_Byte, No_PresP0,[MatchROM, Str ROM_NO, ReadMem, DSAddr, 0]
    
    ORead DQ, Byte_NoRes, No_PresP0, [Str Result \10]  
    Str CMDArray = ReadMem  , DSAddr, 0 
    GoSub CRC_Update[0, 0 , 0, 0, 3], CRC16
    Str CMDArray =  Str Result \8
    GoSub CRC_Update[CRC16Copy.HighByte,CRC16Copy.LowByte,Result[8], Result[9], 8], CRC16
    If CRC16<>0 Then 
    Print At 2,0, "ADC CRC Error ", DEC2 CurrDev,"     "
    HRSOut   "ADC CRC Error ", DEC2 CurrDev
    HRSOut  " ", DEC4 ADC_Acc[0], " ",BIN16 ADC_Acc[0] ,13,10
    Inc CRC16E
'    GoTo ReadPage0
    GoTo setup1 
    EndIf
    If Set_Out=1 Then GoSub SendPage [0]

Return

No_PresP0:
'    Cls
    Print At 2,0, "Page0 No Devices !!!"
    Inc NoPresE
GoTo ReadPage0   

 
ReadPages13: 
    GoSub ReadPage0         
    For MPage=1 To 3         
    ORead DQ, Byte_NoRes, No_PresP13, [Str Result \10]
    If Result[8] = 255 And Result[9] =255 Then No_PresP13
        Str CMDArray = Str Result \8 
        GoSub CRC_Update [0,0, Result[8], Result[9], 8], CRC16 
        If CRC16<>0 Then 
           Print At 2,0, "Page13 CRC Err"
           Inc CRC16E
        EndIf       
    If Set_Out=1 Then GoSub SendPage [MPage]
    Next MPage
Return 
No_PresP13:
'    Cls
    Print At 2,0, "Page1-3 No Devices !"
    Inc NoPresE
GoTo ReadPages13   

       

PrintGLCD:              
      Print At 0,0,  DEC4, ADC_Acc[0]>>MashtabShift,  " ", DEC4, ADC_Acc[1]>>MashtabShift 
      Print At 1,0,  DEC4, ADC_Acc[2]>>MashtabShift,  " ", DEC4, ADC_Acc[3]>>MashtabShift
       
      Print At 0,12, DEC4, ADC_Acc[4]>>MashtabShift,  " ", DEC4, ADC_Acc[5]>>MashtabShift 
      Print At 1,12, DEC4, ADC_Acc[6]>>MashtabShift,  " ", DEC4, ADC_Acc[7]>>MashtabShift
      
      Print At 3,0,  DEC4, ADC_Acc[8]>>MashtabShift,  " ", DEC4, ADC_Acc[9]>>MashtabShift 
      Print At 4,0,  DEC4, ADC_Acc[10]>>MashtabShift, " ", DEC4, ADC_Acc[11]>>MashtabShift
 
      Print At 3,12, DEC4, ADC_Acc[12]>>MashtabShift, " ", DEC4, ADC_Acc[13]>>MashtabShift 
      Print At 4,12, DEC4, ADC_Acc[14]>>MashtabShift, " ", DEC4, ADC_Acc[15]>>MashtabShift
      Print At 5,0,  "NoPE CRC8 CRCH TOTL "
      Print At 6,0,  DEC4 NoPresE, " ", DEC4 CRC8E, " ", DEC4 CRC16E, " ", DEC5 Total  
        
Return  
      


' GoSub Match_SetPage [PageNo]  
' GoSub ReadPage               must be done before
PrintPages:  
      ' Page0       
''    Print At 0,0, HEX4 ResultW[0]," ", HEX4 ResultW[1]
''    Print At 1,0, HEX4 ResultW[2]," ", HEX4 ResultW[3]
''    Print At 2,0, HEX4 ResultW[4]," ", HEX4 CRC16
    
'      Page1       
''    Print At 4,0, HEX4 ResultW[0]," ", HEX4 ResultW[1]
''    Print At 5,0, HEX4 ResultW[2]," ", HEX4 ResultW[3]
''    Print At 6,0, HEX4 ResultW[4]," ", HEX4 CRC16
    
      ' Page2
''    Print At 0,12, HEX4 ResultW[0]," ", HEX4 ResultW[1]
''    Print At 1,12, HEX4 ResultW[2]," ", HEX4 ResultW[3]
''    Print At 2,12, HEX4 ResultW[4]," ", HEX4 CRC16
    
'    'Page3    
''    Print At 4,12, HEX4 ResultW[0]," ", HEX4 ResultW[1]
''    Print At 5,12, HEX4 ResultW[2]," ", HEX4 ResultW[3]
''    Print At 6,12, HEX4 ResultW[4]," ", HEX4 CRC16

Return



SendADC:
    B = RegDevs * 4    
    HRSOut CMD, B     ',13,10    
     
    For I=0 To 4*RegDevs -1    
'    HRSOut HEX4 ADC_Acc[I]>>MashtabShift," " 
    HRSOut ADC_Acc[I]                       '>>MashtabShift      
    Next I
'    HRSOut 13,10
    ADC_Out=0        
Return

SendPage:
    HRSOut DEC2 CurrDev," ", DEC1 MPage," ", HEX4 ResultW[0]," ",DEC4 ResultW[0]>>4," ", HEX4 ResultW[1],_ 
                        " ", HEX4 ResultW[2]," ", HEX4 ResultW[3],LF,CR  
'    set_out=0                      
Return


Setup:      
'Set Channel A-D to Resol_12 bit resolution and to 5.12V reference
      DSAddr=8
      OWrite DQ, Res_Byte, SetNopres,[Scip_ROM]
      
      Str CMDArray =  WriteMem, DSAddr, $00, Resol  
      
      OWrite DQ, Byte_NoRes, SetNopres,[Str CMDArray \4]       
      ORead  DQ, Byte_NoRes, SetNopres,[Str Result \3]   
                    
      GoSub CRC_Update [0,0, Result[0], Result[1], 4], CRC16
      If CRC16<>0 Then  Print At 7,0, "S1"
      
      For DSAddr =9 To 15   
        If DSAddr.0=1 Then    
        Str CMDArray = Range 
        Else
        Str CMDArray = Resol         
        EndIf   
  
        OWrite DQ, Byte_NoRes, SetNopres,[Str CMDArray \1]
        ORead  DQ, Byte_NoRes, SetNopres,[Str Result \3]
        
        GoSub CRC_Update [0,DSAddr,Result[0], Result[1], 1], CRC16
        If CRC16<>0 Then   Print At 7,3, "S2"
         
      Next DSAddr
      
      For DSAddr=16 To 23
          If DSAddr.0=0 Then    
             Str CMDArray = 0  
          Else
             Str CMDArray = $FF
          EndIf
             
          OWrite DQ, Byte_NoRes, SetNopres,[Str CMDArray \1]
          ORead  DQ, Byte_NoRes, SetNopres,[Str Result \3]
          
          GoSub CRC_Update [0,DSAddr,Result[0], Result[1], 1], CRC16
          If CRC16<>0 Then  Print At 7,6, "S3"
           
      Next DSAddr
      
          DSAddr=$1C 
          OWrite DQ, Res_Byte, SetNopres,[Scip_ROM]
          Str CMDArray = WriteMem,DSAddr,0,$40
          OWrite DQ, Byte_NoRes, SetNopres,[Str CMDArray \4]
          ORead  DQ, Byte_NoRes, SetNopres,[Str Result \3] 

          GoSub CRC_Update [0,DSAddr,Result[0], Result[1], 4], CRC16
          If CRC16<>0 Then Print At 7,9, "S4"          
Return      

SetNopres:
    Print At 2,0, "Setup No Devices !!!"
    Inc NoPresE
GoTo Setup   

'======================================================
CRC_Update: 
    Dim  Temp              As Byte  
    Dim MsgLen             As Byte   
    Dim ByteCount          As Byte
    Dim CRCHi              As Byte
    Dim CRCLo              As Byte
    Dim CRC16_Lo           As CRC16.LowByte
    Dim CRC16_Hi           As CRC16.HighByte
     
 
    Pop MsgLen
    Pop CRCHi
    Pop CRCLo    
    Pop CRC16.LowByte
    Pop CRC16.HighByte
    
    For ByteCount =0 To MsgLen -1  
       WREG = CMDArray[ByteCount]                 
   
       xorwf   CRC16_Lo,w      ;UV^PQ - The next message byte and the
       movwf   Temp            ;current crc xor'd for the indexes into
                               ;the tables
       movf    CRC16_Hi,W      ;Shift the CRC right 8 bits, i.e.
       movwf   CRC16_Lo        ;UV = ST
                               ;
       clrw                    ;Build CRC_TableHigh from Index1
       btfsc   Temp,0          ;From the description above, we're
        movlw  0xcc            ;forming the A1 B1 byte. However,
       btfsc   Temp,1          ;as a little twist, we actually
        xorlw  0x8d            ;form B1 A1 since we need to shift
       btfsc   Temp,2          ;this right 4 bits before xor'ing
        xorlw  0x0f            ;
       btfsc   Temp,3          ;
        xorlw  0x0a            ;
                               ;
       movwf   CRC16_Hi        ;Set the high byte to B1 A1
       andlw   0xf0            ;grab B1
       xorwf   CRC16_Hi,f      ;Remove it from the high byte (now 0 A1)
       xorwf   CRC16_Lo,f      ;and put it in the low byte
                               ;
       clrw                    ;We need to grab the LSB of D1 (same as msb
       btfsc   CRC16_Hi,3      ;of A1) and xor it with the LSB of Index2.
        movlw  0xcc            ;
       btfsc   Temp,4          ;Now we build CRC_TableHigh from Index2
        xorlw  0xcc            ;We basically do the same thing as
       btfsc   Temp,5          ;above, but this time we build the
        xorlw  0xd8            ;nibbles in order: A2 B2
       btfsc   Temp,6          ;
        xorlw  0xf0            ;
       btfsc   Temp,7          ;
        xorlw  0xa0            ;
                               ;
       xorwf   CRC16_Hi,f      ;Now combine it with the high byte
       movlw   0x01            ;The lsb of D2 (same as msb of A2)
       btfsc   CRC16_Hi,7      ;needs to be combined with the low
        xorwf  CRC16_Lo,f      ;byte  
   Next ByteCount
     CRC16Copy = CRC16 '^ $FFFF
     CRC16.HighByte= CRC16.HighByte & CRCHi
     CRC16.LowByte = CRC16.LowByte  & CRCLo   
Return CRC16
'=============================
  
'===========================================================================
Search:
    id_bit_number = 1
    Last_Zero = 0
RepSearc:    
    OWrite DQ,1,NO_device,[SEARCH_ROM] 'Send the Search ROM command (FO)
Check_bit:
    ORead DQ,4,[id_bit , cmp_id_bit] 'Get response from device

    If id_bit & cmp_id_bit = 1 Then GoTo  NO_device
    If id_bit | cmp_id_bit <>0 Then   ' In normal sequence the bits always are different
       search_direction = id_bit
       GoSub ROM
       LoadBit tempROM , id_ROM_bit , search_direction
       ROM_NO[id_ROM] = tempROM 
    EndIf
    If id_bit | cmp_id_bit = 0 Then GoSub conflict       
    OWrite DQ,4,[search_direction]                      ' send 1 or 0 as search direction
    id_bit_number = id_bit_number + 1                   ' incredement id_bit_number
    If id_bit_number <= 64 Then Check_bit               'head back for next bit     
    If id_bit_number > 64 Then LastDiscrepancy = Last_Zero
    If LastDiscrepancy = 0 Then LastDeviceFlag = 1
    Inc DeviceCount       

    GoSub CALC_CRC8
NO_device:   
Return      'Search
 
'print at 0,0, "No Devices        "
'goto  RepSearc
'************************** Subs ************************************

Display_result:
    If CRC8<>0 Then
       Print At 0,0,"CRC8 Error     "
'       HRSOut "CRC8 Error     ", 13,10
       Inc CRC8E
       GoTo exit
    EndIf

    If DeviceCount =0 Then 
'       HRSOut "No device",13,10
       Cls
       Print At 0,0, "No Devices     "
       GoTo exit
    EndIf
    Cls
    For B = 1 To RegDevs 

        For I=0 To 7 : ROM_NO[I]= CRead FlashDevAd + I + (B-1) * 8 : Next I 
        
        Print At B, 0, DEC2 B , " ", HEX2 ROM_NO[7]," ",HEX2 ROM_NO[6],HEX2 ROM_NO[5],_
        HEX2 ROM_NO[4],HEX2 ROM_NO[3],HEX2 ROM_NO[2],HEX2 ROM_NO[1]," ",HEX2 ROM_NO[0]
    Next B

    If LastDeviceFlag = 1 Then 
       Inc Total
       Print At 0,0, "               "
       Print At DeviceCount +1, 0," Devices found ",DEC2 DeviceCount 
       Print At 7,0, "Err ", DEC3 CRC8E, At 7,9, "Tot ", DEC8 Total 
exit:
       DelayMS 200
'       Cls
    EndIf
Return
'==============================================================
conflict:
' id_bit_number = LastDiscrepancy then take "1" path
    If id_bit_number = LastDiscrepancy Then
       search_direction = 1
       GoSub ROM
       LoadBit tempROM , id_ROM_bit , search_direction
       ROM_NO[id_ROM] = tempROM 
    EndIf

'id_bit_number > LastDiscrepancy then take the "0" path

    If id_bit_number > LastDiscrepancy Then
       search_direction = 0
       GoSub ROM
       LoadBit tempROM , id_ROM_bit , search_direction
       ROM_NO[id_ROM] = tempROM 
       GoSub Family
    EndIf

' id_bit_number < LastDiscrepancy then take same path as last time

    If id_bit_number < LastDiscrepancy Then 
       GoSub ROM
       search_direction = GetBit tempROM,id_ROM_bit 
       If search_direction = 0 Then GoSub Family
    EndIf
Return
'----------------------------------------------
Family:                      'LastFamilyDiscrepancy bit index set
    Last_Zero = id_bit_number
    If Last_Zero < 9 Then LastFamilyDiscrepancy = Last_Zero
'    EndIf
Return
'------------------------------------------
ROM:
    id_ROM = (id_bit_number - 1) / 8
    id_ROM_bit = (id_bit_number - 1) - (id_ROM * 8)
    tempROM = ROM_NO[id_ROM]
Return  


CALC_CRC8:
    Dim CRCDATA As Byte
    Dim POINTER_2 As Byte
    Dim TESTBIT As Bit
    CRC8 = 0
    For MAIN_BYTE_CNT = 0 To 7                      ' LOOP THROUGH THE ARRAY 
        CRCDATA = ROM_NO[MAIN_BYTE_CNT]    
        For POINTER_2 = 0 To 7                      ' DO FOR ALL 8 BITS IN DATA BYTE
            TESTBIT = CRC8.0 ^ CRCDATA.0             ' XOR BIT0 OF DATA BYTE AND CRC8 
            CRCDATA = CRCDATA >> 1                  ' POSITION DATA BYTE FOR NEXT BIT TEST 
            If TESTBIT = 1 Then                     ' IF TEST BIT NOT SET, JUSTSHIFT CRC8 
                CRC8 = CRC8 ^ $18 
            EndIf                                   ' IF SET, ACCOUNT FOR EXOR FEEDBACK 
            CRC8 = CRC8 >> 1                          ' SHIFT RIGHT THE CRC8 BYTE  CRC8 BIT 0 TO BIT BUCKET 
            CRC8.7 = TESTBIT                         ' TEST BIT ROTATES INTO CRC8 BIT 7 
        Next POINTER_2         
    Next MAIN_BYTE_CNT

Return    

SortDevs:
    Total = 0     
    Cls
    CErase FlashDevAd
    DeviceCount = 0
    LastFamilyDiscrepancy = 0
    LastDiscrepancy = 0
    LastDeviceFlag = 0
    RegDevs=0

    While 1 =1
        GoSub Search
        If CRC8<>0 Then Restart
        If DeviceCount=0 Then
           RegDevs =0 
           GoTo Restart
        EndIf
  
       For I=1 To RegDevs  
           Equal=1
           For B=0 To 7
 
               FlashRead = CRead FlashDevAd + (I-1) * 8 + B ' ONLY THIS        
               If ROM_NO[B] <>  FlashRead Then Equal = 0    ' WAY!
                            
           Next B
           If Equal=1 Then GoTo Old_Dev
       Next I     
       Inc RegDevs
       EWrite  Dev_NumAd, [RegDevs] 
       CWrite  FlashDevAd + (RegDevs -1)*8, [ROM_NO[0],ROM_NO[1],ROM_NO[2],ROM_NO[3],ROM_NO[4],ROM_NO[5],ROM_NO[6],ROM_NO[7]]    
Old_Dev:


       If LastDeviceFlag = 1 Then
       If DeviceCount<> RegDevs Then RegDevs = DeviceCount : EWrite  Dev_NumAd, [RegDevs]
       
Restart:
          GoSub Display_result
'          CErase FlashDevAd   
          DeviceCount = 0
          LastFamilyDiscrepancy = 0
          LastDiscrepancy = 0
          LastDeviceFlag = 0
       EndIf
    If PORTA.0 = 0 Or ExitSort=1 Then 
    EWrite Dev_NumAd, [RegDevs]
    ExitSort=0
    GoTo MainLoop 
    EndIf
    Wend


Include "FONT.INC"

    Org $4000
Storage: 
    CData 0x81, 0x55, 0x22, 0x24, 0x00, 0x00, 0x00, 0x6A         
    CData 0x20, 0xAC, 0xC7, 0x0A, 0x00, 0x00, 0x00, 0xA6 
    CData 0x20, 0xA5, 0xC1, 0x0A, 0x00, 0x00, 0x00, 0xA7 
    CData 0x20, 0x0D, 0xCB, 0x0A, 0x00, 0x00, 0x00, 0xFE 
    CData 0x20, 0xF8, 0xB8, 0x0A, 0x00, 0x00, 0x00, 0x90

        
